<?php  
/* 
Plugin Name: tweetget Widget 
Plugin URI:  http://www.wildbits.de
Description: Simple widget to get the latest tweet form a twitter rss 
Version: 1.0.3 
Author: Thomas Boley
Author URI: http://www.wildbits.de 
*/  

/*

includes

*/

if (!class_exists('templateparser')) {
	include_once ('templateParser_class.php');
}

if (file_exists (ABSPATH . WPINC . '/class-feed.php')) {
	require_once (ABSPATH . WPINC . '/class-feed.php');
}
else {

	require_once (ABSPATH.PLUGINDIR.'/tweetget/simplepie.inc');
}


/*

class tweetget

*/

class tweetget extends WP_Widget {  
    
    function tweetget() {  
        parent::WP_Widget(false, $name = 'tweetget');     
    }  
  

    function widget($args, $instance) { 
          
        extract( $args );  
        echo $before_widget; 
        echo $before_title.$instance['title'].$after_title;  
                  	
		// init simplepie

		$twitter_feed = new SimplePie();
		$twitter_feed->set_feed_url('http://twitter.com/statuses/user_timeline/'.$instance['username'].'.rss');
		$twitter_feed->enable_cache(false);
		$twitter_feed->init();
		$twitter_feed->handle_content_type();
		
		// get feed items
		
		$content = '';
		
		$feeditems = array();
		foreach($twitter_feed->get_items() as $item) {
			$temp_title = $item->get_title();
			$temp_title = preg_replace('/'.$instance['username'].':/','',$temp_title);
			array_push ($feeditems,array ('title'=>$temp_title,'link'=>$item->get_link()));
			
			}
			
		for($i = 0; $i < $instance['tweets']; $i++) {
			$innerTemplate= new  templateparser(ABSPATH.PLUGINDIR.'/tweetget/frontend_tmpl.html');
			$innerTemplate->set_parameter('TWEETURL',$feeditems[$i]['link']);
			$innerTemplate->set_parameter('TWEET',$feeditems[$i]['title']);
			$content .=$innerTemplate->get_output();	
			
			}
		
		$wrapTemplate = new  templateparser(ABSPATH.PLUGINDIR.'/tweetget/wrap_tmpl.html');
		$wrapTemplate->set_parameter('CONTENT',$content);
		
		$wrapTemplate->the_output();
	
	echo $after_widget;   
         
    }  
  
    function update($new_instance, $old_instance) {               
        
        $instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['username'] = strip_tags($new_instance['username']);
		$instance['tweets'] = strip_tags($new_instance['tweets']);
		
		return $instance;
    }  
  

    function form($instance) {  
                  
        $title = esc_attr($instance['title']);
        $username = esc_attr($instance['username']);
        $tweets = esc_attr($instance['tweets']);
        
        $innerTemplate= new  templateparser(ABSPATH.PLUGINDIR.'/tweetget/backend_tmpl.html');
        
        $innerTemplate->set_parameter('FIELDTITLEID',$this->get_field_id('title'));
        $innerTemplate->set_parameter('FIELDTITLE',__('Title:'));
        $innerTemplate->set_parameter('FIELDNAMETITLE',$this->get_field_name('title'));
        $innerTemplate->set_parameter('TITLE',$title);
        $innerTemplate->set_parameter('USERNAME',$username);
        $innerTemplate->set_parameter('USERNAMEID',$this->get_field_id('username'));
        $innerTemplate->set_parameter('USERNAMENAME',$this->get_field_name('username'));
        $innerTemplate->set_parameter('TWEETS',$tweets);
        $innerTemplate->set_parameter('TWEETSID',$this->get_field_id('tweets'));
        $innerTemplate->set_parameter('TWEETSNAME',$this->get_field_name('tweets'));
           
        
        $innerTemplate->the_output(); 
    }  
}  

add_action('widgets_init', create_function('', 'return register_widget("tweetget");'));  
?>